<app-loading *ngIf="isLoading"></app-loading>
<form nz-form [formGroup]="form">
  <div nz-row [nzGutter]="[30, 10]">
    <div nz-col nzXs="24" nzLg="11">
      <mb-select
        [mbDataSelects]="istOptions"
        [mbType]="
          isSubmitted && form.controls['istId'].errors ? 'error' : 'default'
        "
        [mbShowError]="isSubmitted && form.controls['istId'].errors !== null"
        [mbErrors]="form.controls['istId'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.statusSetting.label.istId'
          }
        ]"
        mbPlaceholder="{{
          'insurance.placeholder.select'
            | translateLabel: 'insurance.statusSetting.label.istId'
        }}"
        mbLabelText="{{
          'insurance.statusSetting.label.istId' | translate
        }} <span class='label__required'>*</span>"
        formControlName="istId"
      ></mb-select>
    </div>

    <div nz-col nzXs="24" nzLg="11"></div>

    <div nz-col nzXs="24" nzLg="11">
      <mb-select
        [mbDataSelects]="statusOptions"
        [mbType]="
          isSubmitted && form.controls['flagStatus'].errors
            ? 'error'
            : 'default'
        "
        [mbShowError]="
          isSubmitted && form.controls['flagStatus'].errors !== null
        "
        [mbErrors]="form.controls['flagStatus'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.common.label.flagStatus'
          }
        ]"
        mbPlaceholder="{{
          'insurance.placeholder.select'
            | translateLabel: 'insurance.common.label.flagStatus'
        }}"
        mbLabelText="{{
          'insurance.common.label.flagStatus' | translate
        }} <span class='label__required'>*</span>"
        formControlName="flagStatus"
      ></mb-select>
    </div>

    <div nz-col nzXs="24" nzLg="11">
      <mb-date-picker
        [mbType]="
          isSubmitted && form.controls['fromDate'].errors ? 'error' : 'default'
        "
        [mbShowError]="isSubmitted && form.controls['fromDate'].errors !== null"
        [mbErrors]="form.controls['fromDate'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'required',
            errorDescription:
              'insurance.validate.required'
              | translateLabel: 'insurance.common.label.fromDate'
          }
        ]"
        formControlName="fromDate"
        mbLabelText="{{
          'insurance.common.label.fromDate' | translate
        }} <span class='label__required'>*</span>"
      ></mb-date-picker>
    </div>
    <ng-container
      *ngFor="let formArrayName of formArrayNames"
      [formArrayName]="formArrayName"
    >
      <ng-container
        *ngFor="
          let parameter of getFormArray(formArrayName).controls;
          let i = index;
          let isFirst = first
        "
      >
        <ng-container [formGroupName]="i">
          <div nz-col nzXs="24" nzLg="11">
            <mb-select
              (ngModelChange)="onCodeChange(formArrayName, i, $event)"
              [mbDataSelects]="conditionOptions"
              [mbType]="
                (isSubmitted && parameter['controls']['code'].errors) ||
                parameter['controls']['code'].errors?.conflict
                  ? 'error'
                  : 'default'
              "
              [mbShowError]="
                (isSubmitted &&
                  parameter['controls']['code'].errors !== null) ||
                parameter['controls']['code'].errors?.conflict
              "
              [mbErrors]="parameter['controls']['code'].errors"
              [mbErrorDefs]="[
                {
                  errorName: 'required',
                  errorDescription:
                    'insurance.validate.required'
                    | translateLabel: 'insurance.statusSetting.label.code'
                },
                {
                  errorName: 'conflict',
                  errorDescription:
                    'insurance.participationInformation.validate.conflictCode'
                    | translate
                }
              ]"
              mbPlaceholder="{{
                'insurance.placeholder.select'
                  | translateLabel: 'insurance.statusSetting.label.code'
              }}"
              mbLabelText="{{
                isFirst
                  ? formArrayName === 'leftParameters'
                    ? parameterLabel
                    : alertLabel
                  : ''
              }}"
              formControlName="code"
            ></mb-select>
          </div>
          <div nz-col nzXs="24" nzLg="11">
            <ng-container
              [ngSwitch]="dataTypeDict[parameter['controls']['code'].value]"
            >
              <mb-input-text
                *ngSwitchCase="filterCriteriaDataTypes.NUMBER"
                appNumberInput
                [mbType]="
                  isSubmitted && parameter['controls']['value'].errors
                    ? 'error'
                    : 'default'
                "
                [mbShowError]="
                  isSubmitted && parameter['controls']['value'].errors !== null
                "
                [mbErrors]="parameter['controls']['value'].errors"
                [mbErrorDefs]="[
                  {
                    errorName: 'required',
                    errorDescription:
                      'insurance.validate.required'
                      | translateLabel: 'insurance.statusSetting.label.value'
                  }
                ]"
                mbPlaceholderText="{{
                  'insurance.placeholder.input'
                    | translateLabel: 'insurance.statusSetting.label.value'
                }}"
                mbLabelText="{{ isFirst ? valueLabel : '' }}"
                formControlName="value"
              ></mb-input-text>
              <mb-select
                *ngSwitchCase="filterCriteriaDataTypes.NUMBER_LIST"
                [mbDataSelects]="
                  conditionDict[parameter['controls']['code'].value]
                "
                [mbType]="
                  isSubmitted && parameter['controls']['value'].errors
                    ? 'error'
                    : 'default'
                "
                [mbShowError]="
                  isSubmitted && parameter['controls']['value'].errors !== null
                "
                [mbErrors]="parameter['controls']['value'].errors"
                [mbErrorDefs]="[
                  {
                    errorName: 'required',
                    errorDescription:
                      'insurance.validate.required'
                      | translateLabel: 'insurance.statusSetting.label.value'
                  }
                ]"
                mbPlaceholder="{{
                  'insurance.placeholder.select'
                    | translateLabel: 'insurance.statusSetting.label.value'
                }}"
                mbLabelText="{{ isFirst ? valueLabel : '' }}"
                formControlName="value"
              ></mb-select>
              <mb-select
                *ngSwitchCase="filterCriteriaDataTypes.LIST"
                mbMode="multiple"
                [mbDataSelects]="
                  conditionDict[parameter['controls']['code'].value]
                "
                [mbType]="
                  isSubmitted && parameter['controls']['value'].errors
                    ? 'error'
                    : 'default'
                "
                [mbShowError]="
                  isSubmitted && parameter['controls']['value'].errors !== null
                "
                [mbErrors]="parameter['controls']['value'].errors"
                [mbErrorDefs]="[
                  {
                    errorName: 'required',
                    errorDescription:
                      'insurance.validate.required'
                      | translateLabel: 'insurance.statusSetting.label.value'
                  }
                ]"
                mbPlaceholder="{{
                  'insurance.placeholder.select'
                    | translateLabel: 'insurance.statusSetting.label.value'
                }}"
                mbLabelText="{{ isFirst ? valueLabel : '' }}"
                formControlName="value"
              ></mb-select>
              <mb-date-picker
                *ngSwitchCase="filterCriteriaDataTypes.DATE"
                [mbType]="
                  isSubmitted && parameter['controls']['value'].errors
                    ? 'error'
                    : 'default'
                "
                [mbShowError]="
                  isSubmitted && parameter['controls']['value'].errors !== null
                "
                [mbErrors]="parameter['controls']['value'].errors"
                [mbErrorDefs]="[
                  {
                    errorName: 'required',
                    errorDescription:
                      'insurance.validate.required'
                      | translateLabel: 'insurance.statusSetting.label.value'
                  }
                ]"
                formControlName="value"
                mbLabelText="{{ isFirst ? valueLabel : '' }}"
              ></mb-date-picker>
              <mb-input-text
                *ngSwitchDefault
                [mbType]="
                  isSubmitted && parameter['controls']['value'].errors
                    ? 'error'
                    : 'default'
                "
                [mbShowError]="
                  isSubmitted && parameter['controls']['value'].errors !== null
                "
                [mbErrors]="parameter['controls']['value'].errors"
                [mbErrorDefs]="[
                  {
                    errorName: 'maxlength',
                    errorDescription:
                      'insurance.validate.maxLength'
                      | translate: { numberLength: '50' }
                  },
                  {
                    errorName: 'required',
                    errorDescription:
                      'insurance.validate.required'
                      | translateLabel: 'insurance.statusSetting.label.value'
                  }
                ]"
                mbPlaceholderText="{{
                  'insurance.placeholder.input'
                    | translateLabel: 'insurance.statusSetting.label.value'
                }}"
                mbLabelText="{{ isFirst ? valueLabel : '' }}"
                formControlName="value"
              ></mb-input-text>
            </ng-container>
          </div>
          <div
            *ngIf="isFirst"
            nz-col
            nzXs="24"
            nzLg="2"
            style="margin: 28px 0 20px -34px"
          >
            <mb-button
              (click)="addParameter(formArrayName)"
              mbButtonType="NO_BORDER"
              mbButtonIconType="AWESOME"
              mbButtonSize="LARGE"
              mbPrefixIcon="fal fa-plus-circle"
              mbButtonTextColor="#fff"
              mbButtonBgColor="#141ED2"
            ></mb-button>
          </div>
          <div
            *ngIf="!isFirst"
            nz-col
            nzXs="24"
            nzLg="2"
            style="margin: 5px 0 20px -34px"
          >
            <mb-button
              (click)="removeParameter(formArrayName, i)"
              mbButtonType="NO_BORDER"
              mbButtonIconType="AWESOME"
              mbButtonSize="LARGE"
              mbPrefixIcon="fal fa-trash-alt"
              mbButtonTextColor="#fff"
              mbButtonBgColor="#FA0B0B"
            ></mb-button>
          </div>
        </ng-container>
      </ng-container>
    </ng-container>
    <div nz-col nzXs="24" nzLg="24">
      <mb-input-text
        [mbIsTextAre]="true"
        [mbType]="
          isSubmitted && form.controls['description'].errors
            ? 'error'
            : 'default'
        "
        [mbShowError]="
          isSubmitted && form.controls['description'].errors !== null
        "
        [mbErrors]="form.controls['description'].errors"
        [mbErrorDefs]="[
          {
            errorName: 'maxlength',
            errorDescription:
              'insurance.validate.maxLength'
              | translate: { numberLength: '250' }
          }
        ]"
        formControlName="description"
        mbPlaceholderText="{{
          'insurance.placeholder.input'
            | translateLabel: 'insurance.statusSetting.label.description'
        }}"
        mbLabelText="{{
          'insurance.statusSetting.label.description' | translate
        }}"
      >
      </mb-input-text>
    </div>
  </div>
</form>
